//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

/*
	*******************************************************************
	All examples in this support document are only intended
	to improve understanding of the functionality and 
	handling of the equipment. 
	Beijer Electronics Inc. cannot assume any liability if these
	examples are used in real applications.
	In view of the wide range of applications for this 
	equipment, users must acquire sufficient knowledge 
	themselves in order to ensure that it is correctly used in 
	their specific application. Persons responsible for the 
	application and the equipment must themselves 
	ensure that each application is in compliance with all 
	relevant requirements, standards and legislation in 
	respect to configuration and safety.
	Beijer Electronics Inc. will accept no liability for any 
	damage incurred during the installation or use of this 
	equipment.
	Beijer Electronics Inc. prohibits all modification, changes
	or conversion of the equipment.
	*******************************************************************
	*/

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
    using System.Runtime.InteropServices;
	using System.Threading;  //must add
	using System.IO;  //must add
    
	public partial class USBcheck
	{
		/// <summary>
		/// The method is invoked when the script module object is created.
		/// </summary>
		
		//Setup power state for reboot.
		[DllImport("coredll.dll", SetLastError = true)]
		static extern int SetSystemPowerState(string psState, int StateFlags, int Options);

		const int POWER_FORCE = 4096;
		const int POWER_STATE_RESET = 0x00800000;
		
		
		void USBcheck_Created(System.Object sender, System.EventArgs e)
		{
			Thread MyThread = new Thread(CheckThread);			// Create new thread
			MyThread.Start();									// Start thread
		}

		/// <summary>
		/// The code below runs in a separate thread, checks for a USB-key and sleeps.  If USB found, then reboot.
		/// </summary>
		private void CheckThread()
		{
			while(true)
			{
				if(Directory.Exists("\\Hard Disk\\Project"))	
				{
					// Check if USB key is connected
					//This assumes a single project on the USB that resides at the root level.
					Globals.Tags.USBkeyConnected.Value = 1;
					// call reboot if screen is operative for more than 100 seconds (gives operator time to pull USB out)
					if(Globals.Tags.Count.Value > 100)
					{
						Reboot();
					}
					
				}
				else
					Globals.Tags.USBkeyConnected.Value = 0;		// Reset tag if disconnected
				Thread.Sleep(3000);								// Sleep for 3sec until next check
			}
		}
		public void Reboot()
		{
			if(Environment.OSVersion.Platform == PlatformID.WinCE)
			{
				SetSystemPowerState(null, POWER_STATE_RESET, POWER_FORCE);
				MessageBox.Show("Panel should have rebooted now.");				
			}
			else
			{
				MessageBox.Show("You cannot reboot in simulation mode,"+Environment.NewLine+" a panel would have rebooted now.");
			}
		}
    }
}
